#include "util.h"
#include "graph.h"
#include <stdio.h>

static const int waitTimeout = 20000;

//ϐ錾
int nRefCount = 0;
HINSTANCE hInst;
string strPath;
DWORD dwThreadId;
HANDLE hGraphWndThread = NULL;
HANDLE hGraphWndThreadEvent;
time_t tPrev;
DWORD dwPrev;
int nSeconds = 0;

CGraph * volatile pGraphWnd = NULL;

// eݒ荀
map<string, map<string, string> > mConfig;

vector<string> vUseTimeLabel;
vector<int>    vUseTimeData;
int nUseTimeSeconds;
int nUseTimePrevDay;
DWORD dwUseTimePrev;

/*======================================================
	WindowProc
======================================================*/
LRESULT CALLBACK GraphWndProc(HWND hwnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg) {
	case WM_CREATE:
		SetTimer(hwnd, 100, 100, NULL);
		break;
	case WM_PAINT: {
		RECT rc;
		GetClientRect(hwnd, &rc);
		int nWidth  = rc.right  - rc.left;
		int nHeight = rc.bottom - rc.top;
		
		HDC hdcDesktop = GetDC(NULL);
		HDC hdcBuf = CreateCompatibleDC(hdcDesktop);
		HGDIOBJ hOldBufBmp = SelectObject(hdcBuf, CreateCompatibleBitmap(hdcDesktop, nWidth, nHeight));
		SetBkMode(hdcBuf, TRANSPARENT);
		ReleaseDC(NULL, hdcDesktop);
		
		if (pGraphWnd)
			pGraphWnd->OnDraw(hdcBuf);
		
		PAINTSTRUCT ps;
		BeginPaint(hwnd, &ps);
		BitBlt(ps.hdc, 0, 0, nWidth, nHeight, hdcBuf, 0, 0, SRCCOPY);
		EndPaint(hwnd, &ps);
		DeleteObject(SelectObject(hdcBuf, hOldBufBmp));
		DeleteDC(hdcBuf);
		break;
				   }
	case WM_LBUTTONDOWN:
		ReleaseCapture();
		SendMessage(hwnd, WM_NCLBUTTONDOWN, HTCAPTION, 0);
		break;
	case WM_LBUTTONDBLCLK:
		ShowWindow(hwnd, SW_HIDE);
		return 0;
	case WM_TIMER: {
		DWORD dwNow = GetTickCount();
		if (10 * 1000 < dwNow - dwUseTimePrev) {
			time_t tNow = time(NULL);
			nUseTimeSeconds += (dwNow - dwUseTimePrev) / 1000;
			vUseTimeData[6] += nUseTimeSeconds / 60;
			nUseTimeSeconds %= 60;
			tm *t = localtime(&tNow);
			int nToday = t->tm_mday;
			if (nToday != nUseTimePrevDay) {
				nUseTimePrevDay = t->tm_mday;
				
				vUseTimeLabel.erase(vUseTimeLabel.begin());
				vUseTimeLabel.push_back(ToStr(t->tm_mon + 1) + "/" + ToStr(t->tm_mday));
				
				vUseTimeData.erase(vUseTimeData.begin());
				vUseTimeData.push_back(0);
			}
			dwUseTimePrev = dwNow;
		}
		if (pGraphWnd)
			pGraphWnd->OnUpdate();
		break;
				   }
	}
	return DefWindowProc(hwnd, Msg, wParam, lParam);
}

/*======================================================
	EChEXbh
======================================================*/
DWORD CALLBACK GraphWndThread(LPVOID pParam)
{
	//EBhENXo^
	WNDCLASSEX wcex = { sizeof wcex };
	wcex.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wcex.lpfnWndProc   = GraphWndProc;
	wcex.hInstance     = hInst;
	wcex.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = NULL; //(HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszClassName = "hanayu_graph";
	RegisterClassEx(&wcex);
	
	CGraph::m_hWnd = CreateWindowEx(WS_EX_DLGMODALFRAME | WS_EX_TOOLWINDOW, wcex.lpszClassName, "", WS_POPUP, 0, 0, 0, 0, NULL, NULL, hInst, NULL);
	if (!CGraph::m_hWnd) {
		ExitThread(0);
		return 0;
	}
	
	//bZ[W[v
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)) {
		//OtIuWFNgւ̃ubNp
		if ( WaitForSingleObject(hGraphWndThreadEvent,waitTimeout) != WAIT_TIMEOUT ) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			SetEvent(hGraphWndThreadEvent);
		}
	}
	
	if ( CGraph::m_hWnd ) {
		::DestroyWindow(CGraph::m_hWnd);
		CGraph::m_hWnd = NULL;
	}
	ExitThread(0);
	return 0;
}

/*======================================================
	EChE쐬Ɣj
======================================================*/
void CreateGraphWindow(void)
{
	SetEvent(hGraphWndThreadEvent);
	hGraphWndThread = CreateThread(NULL, 0, GraphWndThread, 0, 0, &dwThreadId);
}

void DestroyGraphWindow(void)
{
	if (hGraphWndThread) {
		//I WM_QUIT蓮œāAĂ悤ȂTerminateThread
		PostThreadMessage(dwThreadId,WM_QUIT,0,0);
		if ( WaitForSingleObject(hGraphWndThread, waitTimeout) != WAIT_TIMEOUT ) {
			CloseHandle(hGraphWndThread);
		}
		else {
			//CloseHandle͕sv - łȂƃG[ɂȂ
			TerminateThread(hGraphWndThread, 0);
		}
		hGraphWndThread = NULL;
	}
	delete pGraphWnd;
	pGraphWnd = NULL;
}

/*======================================================
	f[^ۑ
======================================================*/
void SaveData(void)
{
	if (FILE *f = fopen((strPath + "hanayud.txt").c_str(), "w")) {
		time_t tNow = time(NULL);
		tm *t = localtime(&tNow);
		t->tm_mday = nUseTimePrevDay - 7;
		tNow = mktime(t);
		for (int i = 0; i < 7; ++i) {
			++t->tm_mday;
			tNow = mktime(t);
			t = localtime(&tNow);
			fprintf(f, "%04d%02d%02d,%d\n", 1900 + t->tm_year, t->tm_mon + 1, t->tm_mday, vUseTimeData[i]);
		}
		fclose(f);
	}
}

/*======================================================
	request
======================================================*/
extern "C" __declspec(dllexport) HGLOBAL __cdecl request(HGLOBAL h, long *len)
{
	//p[X
	char *szTmp = new char[*len + 1];
	memcpy(szTmp, (char*)h, *len);
	szTmp[*len] = '\0';
	GlobalFree(h);
	
	vector<char*> vpLine;
	SplitString(szTmp, "\r\n", vpLine);
	vector<char*> vpColumn;
	char *p = strstr(vpLine[0], " SAORI/");
	string strCommand(vpLine[0], p - vpLine[0]);
	string strProtoVer = p + 1;
	
	map<string, string> mReq;
	for (UINT i = 1; i < vpLine.size(); ++i) {
		char *p = strchr(vpLine[i], ':');
		if (!p)
			break;
		*p = '\0';
		mReq.insert(map<string, string>::value_type(vpLine[i], p + 2));
	}
	map<string, string> mRes;
	int status = 200;
	
	//
	if (strCommand == "GET Version") {
	}
	else if (strCommand == "EXECUTE") {
		string &strFunc = mReq["Argument0"];
		if (strFunc == "show") {
			vector<string> vLabel;
			vector<int>    vData;
			for (int i = 2; mReq.count("Argument" + ToStr(i)); i += 2) {
				vLabel.push_back(mReq["Argument" + ToStr(i)]);
				vData.push_back(atoi(mReq["Argument" + ToStr(i + 1)].c_str()));
			}
			string &strStyle = mReq["Argument1"];
			
			//OtIuWFNgւɂ͕KubNĂȂƗ
			if ( WaitForSingleObject(hGraphWndThreadEvent,waitTimeout) != WAIT_TIMEOUT ) {
				delete pGraphWnd;
				pGraphWnd = CGraph::CreateGraph(mConfig[strStyle], vLabel, vData);
				SetEvent(hGraphWndThreadEvent);
				
				ShowWindow(CGraph::m_hWnd, SW_SHOW);
				SetForegroundWindow(CGraph::m_hWnd);
				SendMessage(CGraph::m_hWnd, WM_TIMER, 100, 0);
				InvalidateRect(CGraph::m_hWnd, NULL, TRUE);
				UpdateWindow(CGraph::m_hWnd);
			}
			
		} else if (strFunc == "hide") {
			ShowWindow(CGraph::m_hWnd, SW_HIDE);
			
		}
	} else {
		status = 400;
	}
	
	//
	string strRes;
	if (status == 200) {
		strRes = strProtoVer + " 200 OK\r\n";
		for (map<string, string>::iterator i = mRes.begin(); i != mRes.end(); ++i)
			strRes += i->first + ": " + i->second + "\r\n";
		strRes += "\r\n";
		
	} else if (status == 204) {
		strRes = strProtoVer + " 204 No Content\r\n\r\n";
		
	} else if (status == 400) {
		strRes = "SAORI/1.0 400 Bad Request\r\n\r\n";
		
	} else {
		strRes = strProtoVer + " " + ToStr(status) + " OK\r\n\r\n";
	}
	*len = strRes.length();
	char *pRes = (char*)GlobalAlloc(GMEM_FIXED, *len + 1);
	memcpy(pRes, strRes.c_str(), *len + 1);
	return (HGLOBAL)pRes;
}

/*======================================================
	load
======================================================*/
extern "C" __declspec(dllexport) BOOL __cdecl load(HGLOBAL h, long len)
{
	strPath.assign((char*)h, len);
	GlobalFree(h);
	
	if (++nRefCount != 1)
		return TRUE;
	
	GetNestingEntries(strPath + "hanayu.txt", mConfig, "");
	
	vUseTimeLabel.clear();
	vUseTimeData.clear();
	map<string, string> mUseTimeData;
	GetEntries(strPath + "hanayud.txt", mUseTimeData);
	time_t tNow = time(NULL);
	tm *t = localtime(&tNow);
	t->tm_mday -= 7;
	tNow = mktime(t);
	for (int i = 0; i < 7; ++i) {
		++t->tm_mday;
		tNow = mktime(t);
		t = localtime(&tNow);
		vUseTimeLabel.push_back(ToStr(t->tm_mon + 1) + "/" + ToStr(t->tm_mday));
		char s[256];
		wsprintf(s, "%04d%02d%02d", 1900 + t->tm_year, t->tm_mon + 1, t->tm_mday);
		
		map<string, string>::const_iterator it = mUseTimeData.find(s);
		if ( it != mUseTimeData.end() ) {
			vUseTimeData.push_back(atoi((*it).second.c_str()));
		}
		else {
			vUseTimeData.push_back(0);
		}
	}
	dwUseTimePrev = GetTickCount();
	nUseTimePrevDay = t->tm_mday;
	
	CreateGraphWindow();
	
	return TRUE;
}

/*======================================================
	unload
======================================================*/
extern "C" __declspec(dllexport) BOOL __cdecl unload(void)
{
	if (--nRefCount != 0)
		return TRUE;
	
	DestroyGraphWindow();
	SaveData();
	
	return TRUE;
}

/*======================================================
	DLL
======================================================*/
bool APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	if (ul_reason_for_call == DLL_PROCESS_ATTACH) {
		hInst = (HINSTANCE)hModule;
		DisableThreadLibraryCalls((HINSTANCE)hModule);
		
		hGraphWndThreadEvent = CreateEvent(NULL,TRUE,TRUE,NULL);
		
	}
	else if (ul_reason_for_call == DLL_PROCESS_DETACH) {
		CloseHandle(hGraphWndThreadEvent);
		
		nRefCount = 1;
		unload();
	}
	return true;
}
